C   24/06/87 910032054  MEMBER NAME  BREMS    *.FORT     M  FORTRAN77   0000
      SUBROUTINE BREMS(NX,NY,NP,IXY,ENG,XY,XY0,Q,NPZ,NPZ0,SIG,          0000
     %    MAXLEP,NLEP,IDLE,LEOR,EELE,XYLE,                              0000
     %    ELEMIN,ELEMAX,THINLE,CONSBR,IRR)                              0000
C LOW ENERGY PARTICLE BY BREMSSTRAHLUNG                                 0000
C    BEAMSIZE EFFECT TAKEN INTO ACCOUNT                                 0000
C    ANGULAR DISTRIBUTION IGNORED.                                      0000
C    Forward of beam#1 only.                                            0000
C  CROSS SECTION FORMULA                                                0000
C   ds   8*a*re**2                                                      0000
C  ----=------------[(1-x+3x**2/4)*c-3/4*(13/9-13/9*x+x**2)]            0000
C   dx       3*x                                                        0000
C         c=log(sqrt(2)*sigy/lambda)-(1+Ge)/2                           0000
C         sigy=min(vertical,horizontal) beamsize                        0000
C         lambda=Compton wave length                                    0000
C         Ge=Euler' number =0.5771                                      0000
C         x=Ephoton/E1                                                  0000
C         s=4*E1*Ephoton (E1=initial energy of beam#1)                  0000
C          (dependence on E1 ignored. replaced by E0)                   0000
C         a=fine str.const., re=class.elec.rad, m=rest mass             0000
C                                                                       0000
C                                                                       0000
      REAL*8 Q(NX*NY,2),ENG(NP,2)                                       0000
      INTEGER IDLE(MAXLEP),LEOR(MAXLEP)                                 0000
      REAL*4 EELE(MAXLEP),XYLE(MAXLEP,2,2),THINLE(3)                    0000
      REAL*4 XY0(NP,2,2),XY(NP,2,2),SIG(3,2)                            0000
      INTEGER IXY(NP,2),NPZ(2),NPZ0(2)                                  0000
      DATA CMPTN/3.86159D-13/                                           0000
C                                                                       0000
      L1=1                                                              0000
      L2=3-L1                                                           0000
      C=LOG(SQRT(2.0)*MIN(SIG(1,1),SIG(1,2),SIG(2,1),SIG(2,2))          0000
     %      /CMPTN)-(1.0+0.5771)/2.0                                    0000
      A1=C-13./12.                                                      0000
      A2=0.75*(C-1)                                                     0000
      DO 300 N=NPZ0(L1),NPZ(L1)                                         0000
      IXY1=IXY(N,L1)                                                    0000
      IF(IXY1.LE.0.OR.IXY1.GT.NX*NY) GOTO 300                           0000
      IF(Q(IXY1,L2).EQ.0) GOTO 300                                      0000
      EE=ENG(N,L1)                                                      0000
      XGMIN=MAX(1E-5,(EE-ELEMAX)/EE)                                    0000
      XGMAX=MIN(0.99999E0,(EE-ELEMIN)/EE)                               0000
      IF(XGMIN.GE.XGMAX) GOTO 300                                       0000
      C1=A1*(LOG(XGMIN)-XGMIN)+0.5*A2*XGMIN**2                          0000
      C2=A1*(LOG(XGMAX)-XGMAX)+0.5*A2*XGMAX**2                          0000
      W=C2-C1                                                           0000
      A=Q(IXY1,L2)*CONSBR*W*THINLE(1)                                   0000
      M=INT(A)                                                          0000
      DO 260 I=0,M                                                      0000
      IF(I.LT.M) GOTO 160                                               0000
      IRR=IRR*48828125                                                  0000
      IF(IRR.LT.0) IRR=(IRR-2147483647)-1                               0000
      R=4.656612873E-10*IRR                                             0000
      IF(R.GT.A-M) GOTO 260                                             0000
  160 IRR=IRR*48828125                                                  0000
      IF(IRR.LT.0) IRR=(IRR-2147483647)-1                               0000
      R=4.656612873E-10*IRR                                             0000
      F=R*W+C1                                                          0000
      XE=MIN(ELEMIN/EE,MAX(ELEMAX/EE,0.5-(A1+F)/A2))                    0000
      ITR=0                                                             0000
  200 ITR=ITR+1                                                         0000
      XG=1-XE                                                           0000
      IF(ITR.GE.10.OR.XG.LE.0) THEN                                     0000
          WRITE(6,220)                                                  0000
  220     FORMAT(' (SUBR.BREMS)  ##### PROGRAM ERROR #####')            0000
      GO TO 260
CCC       STOP                                                          0000
        ENDIF                                                           0000
      DXE=(A1*(LOG(XG)-XG)+0.5*A2*XG**2-F)/(A1*(1/XG-1)+A2*XG)          0000
      XE=XE+DXE                                                         0000
      IF(ABS(DXE).GE.1E-5) GOTO 200                                     0000
      IF(NLEP.GE.MAXLEP)                                                0000
     %       CALL CPRSLE(NLEP,MAXLEP,LEOR,EELE,XYLE,THINLE,IRR)         0000
      NLEP=NLEP+1                                                       0000
      LEOR(NLEP)=1                                                      0000
      IDLE(NLEP)=N                                                      0000
      EELE(NLEP)=EE*XE                                                  0000
      XYLE(NLEP,1,1)=XY(N,1,L1)                                         0000
      XYLE(NLEP,2,1)=XY(N,1,L1)-XY0(N,1,L1)                             0000
      XYLE(NLEP,1,2)=XY(N,2,L1)                                         0000
      XYLE(NLEP,2,2)=XY(N,2,L1)-XY0(N,2,L1)                             0000
  260 CONTINUE                                                          0000
  300 CONTINUE                                                          0000
      RETURN                                                            0001
      END                                                               0001
