C   14/04/87 802171647  MEMBER NAME  INIT2    *.FORT     M  FORTRAN77   0000
C******************** INIT2 ********************************************0000
      SUBROUTINE INIT2(KFLD,XYMM,NP,XY,XY0,ZZ,ENG,RP,NPIZ,IZMIN,IZMAX,  0000
     %   DXYZ,DT,RTZ,MT1)                                               0000
C  REDEFINE THE INITIAL CONDITIONS.                                     0000
C  TAKE THE PARTICLES FROM THE I.P. BACK TO THE INITIAL TIME,           0000
C    AND REDEFINE XY0=X AND Y AT THE FIRST TIME STEP AND XY=THOSE       0000
C    AT THE NEXT TIME STEP.                                             0000
C  CHANGE THE UNIT SYSTEM FROM METERS TO THE CELL SIZE (DX,DY,DZ).      0000
C  SORT THE PARTICLES INTO ASCENDING ORDER OF Z.                        0000
C  GROUP THE PARTICLES INTO SUBSLICES WITH WIDTH DT ACCORDING TO THE    0000
C    Z-COORDINATE.                                                      0000
C  NORMALLY, USERS NEED NOT KNOW THIS SUBROUTINE.                       0000
      REAL*4 XYMM(4,7,2,2),DXYZ(3)                                      0000
COLD        REAL*4 XY(NP,2,2),XY0(NP,2,2),ZZ(NP,2),RP(NP,2)             0000
      REAL*4 XY(NP,2,2),XY0(NP,2,2),ZZ(NP,2)
      INTEGER RP(NP,2)
      REAL*8 ENG(NP,2)                                                  0000
      INTEGER NPIZ(IZMIN:IZMAX+1,2)                                     0000
C                                                                       0000
      DO 340 L=1,2                                                      0000
      IF(KFLD.EQ.4) THEN                                                0000
          DO 300 I=1,4                                                  0000
          XYMM(I,1,L,1)=0                                               0000
  300     XYMM(I,2,L,1)=0                                               0000
        ELSE                                                            0000
          CALL AVRG4(XY(1,1,L),NP,XYMM(1,1,L,1))                        0000
          CALL AVRG4(XY0(1,1,L),NP,XYMM(1,2,L,1))                       0000
        ENDIF                                                           0000
      CALL AVRG4(XY(1,2,L),NP,XYMM(1,3,L,1))                            0000
      CALL AVRG4(XY0(1,2,L),NP,XYMM(1,4,L,1))                           0000
      CALL AVRG4(ZZ(1,L),NP,XYMM(1,5,L,1))                              0000
      CALL AVRG8(ENG(1,L),NP,XYMM(1,6,L,1))                             0000
  340 CONTINUE                                                          0000
      DO 500 L=1,2                                                      0000
      DO 380 IXY=1,2                                                    0000
      IF(KFLD.EQ.4.AND.IXY.EQ.1) GOTO 380                               0000
*VOPTION VEC(NOFVAL)                                                    0000
      DO 360 N=1,NP                                                     0000
      XY1=XY(N,IXY,L)                                                   0000
      XYP=XY0(N,IXY,L)                                                  0000
      XY(N,IXY,L)=(XY1+XYP*(MT1*DT+ZZ(N,L)))/DXYZ(IXY)                  0000
  360 XY0(N,IXY,L)=(XY1+XYP*((MT1-1)*DT+ZZ(N,L)))/DXYZ(IXY)             0000
  380 CONTINUE                                                          0000
      DO 400 N=1,NP                                                     0000
  400 ZZ(N,L)=ZZ(N,L)/DXYZ(3)                                           0000
      CALL RSORT2(ZZ(1,L),NP,+2,RP)                                     0000
      CALL DSORT2(ENG(1,L),NP,0,RP)                                     0000
      IF(KFLD.NE.4) CALL RSORT2(XY(1,1,L),NP,0,RP)                      0000
      CALL RSORT2(XY(1,2,L),NP,0,RP)                                    0000
      IF(KFLD.NE.4) CALL RSORT2(XY0(1,1,L),NP,0,RP)                     0000
      CALL RSORT2(XY0(1,2,L),NP,0,RP)                                   0000
C       (SORTING INTO ASCENDING ORDER OF Z)                             0000
C       (RP IS USED AS WORKING AREA)                                    0000
C--- FILL NPIZ(IZ,L) = SMALLEST ID OF THE PARTICLES IN IZ-TH SUBSLICE   0000
C    IN L-TH BEAM. DEFINED FOR IZMIN<=IZ<=IZMAX+1, SO THAT              0000
C    PARTICLE ID IN IZ-TH SUBSLICE IS FROM NPIZ(IZ,L)+1 TO              0000
C    NPIZ(IZ+1,L) (IZMIN<=IZ<=IZMAX).  IF UPPER-LOWER<0, THIS           0000
C    SUBSLICE IS EMPTY.                                                 0000
C    Z-COORDINATE IN IZ-TH SUBSLICE IS IZ*DT <= Z < (IZ+1)*DT.          0000
      DO 440 IZ=IZMIN,IZMAX+1                                           0000
  440 NPIZ(IZ,L)=0                                                      0000
      IZ=IZMIN                                                          0000
      Z1=IZ*RTZ                                                         0000
      N=1                                                               0000
  450 CONTINUE                                                          0000
      IF(ZZ(N,L).GE.Z1) THEN                                            0000
          NPIZ(IZ,L)=N                                                  0000
          IZ=IZ+1                                                       0000
          Z1=IZ*RTZ                                                     0000
        ELSE                                                            0000
          N=N+1                                                         0000
          IF(N.GT.NP) GOTO 460                                          0000
        ENDIF                                                           0000
      GOTO 450                                                          0000
  460 IF(IZ.GT.IZMAX+1) THEN                                            0000
          WRITE(6,470) IZ                                               0000
  470     FORMAT(' !!!! PROGRAM ERROR IN INIT2.  IZ=',I10)              0000
          STOP                                                          0000
        ENDIF                                                           0000
      DO 480 J=IZ,IZMAX+1                                               0000
  480 NPIZ(J,L)=NP+1                                                    0000
  500 CONTINUE                                                          0000
      DO 520 L=1,2                                                      0000
      DO 520 N=1,NP                                                     0000
  520 RP(N,L)=0                                                         0000
      RETURN                                                            0000
      END                                                               0000
