      SUBROUTINE PAIRBH(NTUNE,NBOOST,LOCAL,NFLDEX,NX,NY,NT,RTZ,ZZ,NP,Q,
     %  MAXPH,NPH,IXYP,EPH,XYPH,IPHEL,
     %  IZMM1,IZMIN,IZMAX,IPHIZ,IDPH,THIN,
     %  MAXLEP,NLEP,IDLE,LEOR,EELE,XYLE,
     %  ELEMIN,ELEMAX,THINLE,CONSBH,ENGY,GAM,
     %  ANGMIN,DXYZ,DT,BLEND,UPSLN,IRR)
C***********************************************************************
C PAIR CREATION BY BETHE-HEITLER PROCESS
C************    using real photon approximation
C*   Y1  : Virtual photon
C*   Y2  : Real(Beamstrahlung) photon
C*   Modified the formula of the partial cross section in 7-Jan-1992.
C*     These modifications are shown by CNEW.
C***********************************************************************
      INCLUDE '@DEBUG'
      REAL*4 ZZ(NP,2),EPH(MAXPH,2),XYPH(MAXPH,4,2),ENGY(2),GAM(2)
     *,UPSLN(NX*NY,2)
      INTEGER IPHEL(MAXPH,2),IXYP(MAXPH,2),NPH(2)
      INTEGER IZMM1(2,2),IPHIZ(IZMIN:IZMAX+1,2),IDPH(MAXPH,2)
      REAL*8 Q(NX*NY,2)
      INTEGER IDLE(MAXLEP),LEOR(MAXLEP)
      REAL*4 EELE(MAXLEP),XYLE(MAXLEP,2,2),THINLE(3),DXYZ(3),BLEND(2)
      DATA INIT/0/,PI2/6.28319/
      DATA EMASS/0.5110034D-3/,NCHKYX/40000/,NCHKMX/40000/
      DATA NBSTMX/100000/
      DATA NTRYMX/10000/
CREAL8
      REAL*8 CSPAIR,CS,COSMIN,YM,YP,YB,YG,YGVT,ANGMIN
      REAL*8 SN,ANGCUT
      real*4 dum1,dum2
      REAL*8 ENGLE
      REAL*8 YMMIN,SMIN,YMMIN0,YMMIN1,EGVRTL
CREAL8
C--Set initial parameters
      IF(INIT.EQ.0) THEN
CCC    CSLOG = ALOG( (1.+COSMIN)/(1.-COSMIN) )
CCC    YMMIN = 0.5*ELEMIN*(1.-COSMIN)
      COSMIN= 1.D0 - 0.5D0*ANGMIN**2
      CSLOG = -2.*DLOG( 0.5*ANGMIN )
      YMMIN = 0.25D0*ELEMIN*ANGMIN**2
      SMIN  = (EMASS/ENGY(1))**2
      IF(SMIN.GT.YMMIN) YMMIN=SMIN
      INIT  = 1
CC    PRINT *,'!!!! YMMIN=',YMMIN,' IN PAIRBH'
      ENDIF
C---
      S0 = NT
      L1 = 1
      L2 = 3-L1
C-- Loop over beamstrahlung gamma's
      IF(NPH(L1).LE.0) RETURN
      N1=IPHIZ(IZMM1(1,L1),L1)
      N2=IPHIZ(IZMM1(2,L1)+1,L1)-1
      IF(N2.LT.N1) RETURN
      DO 300 NN=N1,N2
      IXYP1=IXYP(NN,L1)
      IF(IXYP1.LE.0.OR.IXYP1.GT.NX*NY) GOTO 300
      IF(Q(IXYP1,L2).LE.0) GOTO 300
      N = IDPH(NN,L1)
      YG= EPH(N,L1)
      IF( YG.LT.YMMIN ) GO TO 300
CNEW
      YMMIN0 = YMMIN
      YMMIN1 = SMIN/YG
      IF(YMMIN1.GT.YMMIN0)  YMMIN0 = YMMIN1
C---
      CCBH  = ( 1. - (DLOG(YMMIN0)+1.)/YMMIN0 )*CSLOG/YG
C-- Get total number of pairs to be created
      SL    = Q(IXYP1,L2)*CONSBH*CCBH*THINLE(2)/THIN
      if(thinle(2).gt.0.) wgtlep = 1./thinle(2)
CNEW
CNEWNEW
      M  = IFIX(SL)
      DM = SL - M
      IF(DM.GT.RAN(IRR) ) M = M + 1
      IF(M.LE.0) GO TO 300
c       PRINT *,'**PAIRBH-- NLEP,M=',NLEP,M
CNEWNEW
      NREP=0
  120 NREP=NREP+1
      IF(NLEP+2*M.LE.MAXLEP) GOTO 140
      CALL CPRSLE(NLEP,MAXLEP,LEOR,EELE,XYLE,THINLE,IRR)
      IF(NREP.LE.2) GOTO 120
      WRITE(6,130)
  130 FORMAT(' (SUBR.PAIRBH)   ##### PROGRAM ERROR #####')
      STOP
C---
  140 CONTINUE
C---
      DO 260 I=1,2*M
      NCHK = 0
      NCHKY= 0
CANGCHK       IANCHK = 1
CANGCHK       IF(IANCHK.EQ.1) GO TO 1919
261   CONTINUE
      YGVT = EGVRTL(YMMIN0,IRR)
      IF( (YG*YGVT).LT.SMIN  ) GO TO 260
C !!!!
      CS   = CSPAIR(IRR,COSMIN)
      YM   = 0.5*ELEMIN*(1.-CS)
CNEW
C--Check YG(Y2)   < YM
      IF(YG.LE.YM) GO TO 260
      YP   = 0.5*ELEMIN*(1.+CS)
      YB   = YG*YP/(YG - YM)
C--Check YGVT(Y1) < YB
      IF(YGVT.LT.YB) GO TO 260
CNEW
c       PRINT *,'     M,CS,YG,YGVT=',I,CS,YG,YGVT
CCBOOST
      IF(NBOOST.EQ.1) THEN
      CALL CSBOOT(IRR,CS,YGVT,YG,IRTN)
      IF( IRTN.NE.0) GO TO 260
      ENDIF
CCBOOST
C---
CNEW
      ENGLE= 2.D0*YG*YGVT/( YGVT*(1.D0-CS)+YG*(1.D0+CS) )
CNEW
C--CHECK MAX.ENERGY
      IF(ENGLE.LT.ELEMIN.OR.ENGLE.GE.ELEMAX) GO TO 260
C--minimum angle cut  due to electron mass.
      SN   = 1.D0 - CS**2
      SN   = SQRT( SN )
      ANGCUT = ANGBH/GAM(1)/ENGLE
CMAS1          ANGCUT = 1.0/GAM(1)/ENGLE
      IF( SN.LE.ANGCUT ) GO TO 260
C---Supression factor here!!
C******* 
      IF(LOCAL.EQ.0.OR.NFLDEX.EQ.0) THEN
C******* 
        CALL QTVRTL(RTVRTL,YTV,GAM(1),YGVT,IRR)
C-- Effect of the external ele.magnetic field.
        IF(NFLDEX.EQ.0) THEN
         YTVMIN = YGVT*(      UPSLN(IXYP1,L2)/YGVT )**(1./3.)
CNEWEXT           YTVMIN = YGVT*(  1.5*UPSLN(IXYP1,L2)/YGVT )**(1./3.)
CBAIER            YTVMIN = YGVT*( 1. + UPSLN(IXYP1,L2)/YGVT )**(1./3.)
         IF(YTVMIN.GT.0.) CALL HCUM1('RYGT',YTV/YTVMIN,wgtlep)
         IF(YTV.LT.YTVMIN) GO TO 260
        ENDIF
C******* 
      ENDIF
C******* 
C--
CC      IF(LOCAL.EQ.0) THEN
      IF(LOCAL.EQ.0.AND.
     *(NTUNE.NE.2.OR.(NTUNE.EQ.2.AND.RAN(IRR).LT.0.85) ) ) THEN
C--
C-- Non-local intereaction here
      RHO  = RTVRTL
      Z    = ZZ(IPHEL(N,L1),L1)/RTZ+S0
      XGAM = XYPH(N,1,L1)+XYPH(N,2,L1)*Z
      YGAM = XYPH(N,3,L1)+XYPH(N,4,L1)*Z
ccc
      CSMIN = (-1.+BLEND(1) - XGAM )/RHO*DXYZ(1)
      CSMAX = (FLOAT(NX+1.) + BLEND(1) - XGAM )/RHO*DXYZ(1)
      IF(CSMIN.GT.1.0.OR.CSMAX.LT.-1.0) GO TO 260
      SNMIN = (-1.+BLEND(2) - YGAM )/RHO*DXYZ(2)
      SNMAX = (FLOAT(NY+1.) + BLEND(2) - YGAM )/RHO*DXYZ(2)
      IF(SNMIN.GT.1.0.OR.SNMAX.LT.-1.0) GO TO 260
ccc      IF(CSMIN.LT.-1.0) CSMIN=-1.0
ccc      IF(CSMAX.GT.1.0) CSMAX=1.0
ccc
      NTRY = 0
262   CONTINUE
      NTRY = NTRY + 1
      IF(NTRY.GT.NTRYMX) GO TO 260
ccc
ccc      COSPHI = CSMIN + (CSMAX-CSMIN)*RAN(IRR)
ccc      SINPHI = SQRT(1. -COSPHI**2)
ccc      IF(RAN(IRR).GT.0.5) SINPHI=-SINPHI
      PHI  = PI2*RAN(IRR)
      COSPHI = COS(PHI)
      SINPHI = SIN(PHI)
      IF(COSPHI.LT.CSMIN.OR.COSPHI.GT.CSMAX) GO TO 262
      IF(SINPHI.LT.SNMIN.OR.SINPHI.GT.SNMAX) GO TO 262
ccc
      XGAM = XGAM + RHO*COSPHI/DXYZ(1)
      XXGAM = XGAM - BLEND(1)
      IF(XXGAM.LT.0.0.OR.XXGAM.GT.FLOAT(NX) ) GO TO 262
      YGAM = YGAM + RHO*SINPHI/DXYZ(2)
      YYGAM = YGAM - BLEND(2)
      IF(YYGAM.LT.0.0.OR.YYGAM.GT.FLOAT(NY) ) GO TO 262
CCC
      IXGAM= NINT( XXGAM )
      IYGAM= NINT( YYGAM )
      IF(IXGAM.GE.0.AND.IXGAM.LE.NX.AND.IYGAM.GE.0.AND.IYGAM.LE.NY) THEN
        IXYGAM= IXGAM+1+NX*IYGAM
         FRACQ = Q(IXYGAM,L2)/Q(IXYP1,L2)
ccc
         call hcum1('BHFR',fracq,wgtlep)
         if(fracq.gt.1.0) then
          wgtlep = wgtlep
          IF(NTUNE.EQ.3) wgtlep = fracq*wgtlep
            else
cc          IF(RAN(IRR).GT.FRACQ*1.3) GO TO 260
          IF(RAN(IRR).GT.FRACQ) GO TO 260
          endif
         ELSE
        GO TO 260
       ENDIF
C--
      ELSE
C--
      Z    = ZZ(IPHEL(N,L1),L1)/RTZ+S0
      XGAM = XYPH(N,1,L1)+XYPH(N,2,L1)*Z
      YGAM = XYPH(N,3,L1)+XYPH(N,4,L1)*Z
C--
      ENDIF
C---
c      write(6,*) '115 cs = ',cs 
      CS   = ABS(CS)
CANGCHK 1919  CONTINUE
CANGCHK       ENGLE= ELEMIN + (ELEMAX-ELEMIN)*RAN(IRR)
CANGCHK       CS   = 1.0
CANGCHK       Z    = ZZ(IPHEL(N,L1),L1)/RTZ+S0
CANGCHK       XGAM = XYPH(N,1,L1)+XYPH(N,2,L1)*Z
CANGCHK       YGAM = XYPH(N,3,L1)+XYPH(N,4,L1)*Z
CANG100                  CS = 0.995
CANG70                   CS = 0.99755
CANG50                   CS = 0.99875
CANG60                   CS = 0.99820
CANG40                   CS = 0.99920
CANG20                   CS = 0.99980
CANGCHK       IF(ENGLE.LE.0.) THEN
CANGCHK        PRINT *,'!!PAIRBH!!, ELEMIN,ELEMAX,ENGLE=',ELEMIN,ELEMAX,ENGL
CANGCHK       ENDIF
C---
      dum1= cs
      CALL HCUM1('ANBH',dum1,wgtlep)
      dum1 = LOG10(ENGLE)
      CALL HCUM1('EPBH',dum1,wgtlep)
      CALL HCUM1('EPTT',dum1,wgtlep)
      dum1 = LOG10(YG)
      dum2 = LOG10(YGVT)
      CALL HCUM2('EGBH',dum1 ,dum2,wgtlep)
C--
      if(ntune.ne.3.and.fracq.gt.1.) then
      nfracq = ifix(fracq)
      dfracq  = fracq - nfracq
       if(ran(irr).lt.dfracq) nfracq=nfracq+1
       else
      nfracq = 1
      endif
      kfracq = 0
C--
263   continue
C--
      kfracq = kfracq + 1
C---
      IF(CS.LT.1.) THEN
c         write(6,*) cs,cs**2
      SN   = SQRT(1.-CS**2)
      PHI  = PI2*RAN(IRR)
      XNEW          = ATAN2(SN*COS(PHI),CS)*DT/DXYZ(1)
      YNEW          = ATAN2(SN*SIN(PHI),CS)*DT/DXYZ(2)
      ELSE
      XNEW          = 0.
      YNEW          = 0.
      ENDIF
      NLEP = NLEP+1
      LEOR(NLEP)=2
      IF(I.GT.M) LEOR(NLEP)=-2
      IDLE(NLEP)=IPHEL(N,L1)
      EELE(NLEP)=SNGL(ENGLE)
ccc
      WGTLE(NLEP) = wgtlep
ccc
c      write(6,*) '116'
CPRTST            PRINT *,'!! PAIRBH,  NLEP,ENGLE,SN=',NLEP,ENGLE,SN
      XYLE(NLEP,1,1)=XGAM
      XYLE(NLEP,2,1)=XYPH(N,2,L1) + XNEW
      XYLE(NLEP,1,2)=YGAM
      XYLE(NLEP,2,2)=XYPH(N,4,L1) + YNEW
CNOKICK              XYLE(NLEP,2,1)= XNEW
CNOKICK              XYLE(NLEP,2,2)= YNEW
CTEST                XYLE(NLEP,2,1)= XYPH(N,2,L1)
CTEST                XYLE(NLEP,2,2)= XYPH(N,4,L1)
CTEST          XYLE(NLEP,1,1)= XYPH(N,1,L1)+XYPH(N,2,L1)*Z
CTEST          XYLE(NLEP,1,2)= XYPH(N,3,L1)+XYPH(N,4,L1)*Z
ccc
      if(kfracq.lt.nfracq) go to 263
ccc
  260 CONTINUE
  300 CONTINUE
      RETURN
      END


