C   24/06/87 709011052  MEMBER NAME  POTMAT   *.FORT        FORTRAN77   
      SUBROUTINE POTMAT(NX,NY,dum1,dum2,PHIQ,AAA,AAA2)                      
      IMPLICIT REAL*8 (A-H,O-Z)                                         
      REAL*8 PHIQ(0:NX-1,0:NY-1),AAA(NX-1,(NX-2)*(NY-2)),               
     %     AAA2((NX-2)*(NY-2))
**
*  add by T.Takahashi 94/11/21
*   to much type of argument
**
      real*4 dum1,dum2
      dx = dum1
      dy = dum2
C----- PREPARE POTENTIAL MATRIX -----                                   
      write(6,*) 'called potmat', dx,dy 
      NX1=NX-1                                                          
      NX2=NX-2                                                          
      NDIM=NX2*(NY-2)                                                   
      ASP=DY/DX                                                         
      UDFL=1D60                                                         
C       THIS IS TO AVOID UNDERFLOW IN DLB2M                             
      IF(ASP.GT.100.OR.ASP.LE.0.01) THEN                                
          WRITE(6,200)                                                  
  200     FORMAT(' --- UNDERFLOW MAY OCCUR IN SUBR.DLB2M. ',            
     %    'CAN BE IGNORED IF NOT OVERFLOW.')                            
        ENDIF                                                           
      FAC1=-ASP*UDFL                                                    
      FAC2=-UDFL/ASP                                                    
      FAC3=-2.*(FAC1+FAC2)                                              
      CALL CLEAR(AAA,2*NX1*NDIM)                                        
      DO 220 K=1,NDIM                                                   
  220 AAA(NX1,K)=FAC3                                                   
      DO 240 K=NX1,NDIM                                                 
  240 AAA(1,K)=FAC2                                                     
      DO 260 J=0,NY-3                                                   
      JJ=NX2*J                                                          
      DO 260 I=2,NX2                                                    
  260 AAA(NX2,I+JJ)=FAC1                                                
      EPS=1D-12                                                         
      IOPTN=2                                                           
      CALL DLB2M(AAA,NDIM,NX2,NX1,DUMMY,EPS,IOPTN,AAA2,IER)             
C         WRITE(6,9999) (J,(AAA(I,J),I=1,NX1),J=1,NDIM)                 
C9999     FORMAT(1X,I6,1P15D8.1)                                        
      IF(IER.NE.0) THEN                                                 
          WRITE(6,280)                                                  
  280     FORMAT(' --- FATAL ERROR ----. STOP RUN')                     
          STOP                                                          
        ENDIF                                                           
      PHIQ(0,0)=0.0                                                     
      DO 380 J=0,NY-1                                                   
      Y=J**2*ASP                                                        
      DO 380 I=0,NX-1                                                   
  380 IF(I.NE.0.OR.J.NE.0) PHIQ(I,J)=-0.5*LOG(I**2/ASP+Y)               
      PHIQ(0,0)=(PHIQ(1,0)*ASP+PHIQ(0,1)/ASP+0.5D0)/(1D0/ASP+ASP)       
      RETURN                                                            
      END                                                               
